package com.simibubi.create.compat.jei.category.animations;

import com.mojang.blaze3d.platform.GlStateManager;
import com.simibubi.create.AllBlockPartials;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.foundation.gui.ScreenElementRenderer;

import net.minecraft.block.BlockState;
import net.minecraft.client.renderer.model.IBakedModel;

public class AnimatedMillstone extends AnimatedKinetics {

	@Override
	public int getWidth() {
		return 50;
	}

	@Override
	public int getHeight() {
		return 50;
	}

	@Override
	public void draw(int xOffset, int yOffset) {
		GlStateManager.pushMatrix();
		GlStateManager.enableDepthTest();
		GlStateManager.translatef(xOffset, yOffset, 0);
		GlStateManager.rotatef(-15.5f, 1, 0, 0);
		GlStateManager.rotatef(22.5f, 0, 1, 0);
		GlStateManager.translatef(-45, -5, 0);
		GlStateManager.scaled(.45f, .45f, .45f);

		GlStateManager.pushMatrix();
		ScreenElementRenderer.renderModel(this::cogwheel);
		GlStateManager.popMatrix();

		GlStateManager.pushMatrix();
		ScreenElementRenderer.renderBlock(this::body);
		GlStateManager.popMatrix();

		GlStateManager.popMatrix();
	}

	private IBakedModel cogwheel() {
		float t = 25;
		GlStateManager.translatef(t, -t, -t);
		GlStateManager.rotated(getCurrentAngle() * 2, 0, 1, 0);
		GlStateManager.translatef(-t, t, t);
		return AllBlockPartials.MILLSTONE_COG.get();
	}

	private BlockState body() {
		return AllBlocks.MILLSTONE.get().getDefaultState();
	}
}
